/*
 *  BoundingBox.cpp
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/7/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "BoundingBox.h"

namespace PcGeom {

BoundingBox::BoundingBox(const Point3& minP, const Point3& maxP):
	minPoint(minP), maxPoint(maxP) {

}

BoundingBox::BoundingBox(const Vector3& minP, const Vector3& maxP):
	minPoint(Point3(minP.x, minP.y, minP.z)), maxPoint(Point3(maxP.x, maxP.y, maxP.z)) {

}
	
void BoundingBox::addPoint(const Point3& p) { 
	if (p.x < minPoint.x) {
		minPoint.x = p.x;
	}
	if (p.y < minPoint.y) {
		minPoint.y = p.y;
	}
	if (p.z < minPoint.z) {
		minPoint.z = p.z;
	}
			
	if (p.x > maxPoint.x) {
		maxPoint.x = p.x;
	}
	if (p.y > maxPoint.y) {
		maxPoint.y = p.y;
	}
	if (p.z > maxPoint.z) {
		maxPoint.z = p.z;
	}
}


void BoundingBox::addPoint(const Vector3& p) {
	if (p.x < minPoint.x) {
		minPoint.x = p.x;
	}
	if (p.y < minPoint.y) {
		minPoint.y = p.y;
	}
	if (p.z < minPoint.z) {
		minPoint.z = p.z;
	}
			
	if (p.x > maxPoint.x) {
		maxPoint.x = p.x;
	}
	if (p.y > maxPoint.y) {
		maxPoint.y = p.y;
	}
	if (p.z > maxPoint.z) {
		maxPoint.z = p.z;
	}
}
	
double BoundingBox::diagonalSquared() const {
	return minPoint.distanceSquared(maxPoint);
}

Point3 BoundingBox::center() const {
	return Point3(0.5 * (minPoint.x + maxPoint.x),
				  0.5 * (minPoint.y + maxPoint.y),
				  0.5 * (minPoint.z + maxPoint.z));


}
	
}