#ifndef _pc_geom_bounding_box_h_
#define _pc_geom_bounding_box_h_

/*
 *  BoundingBox.h
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/7/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <PcMath/Vector3.h>

#include "Point3.h"

namespace PcGeom {

using PcMath::Vector3;

class BoundingBox {

public:
	BoundingBox(const Point3& minP, const Point3& maxP);
	BoundingBox(const Vector3& minP, const Vector3& maxP);
	
	void addPoint(const Point3& p);
	void addPoint(const Vector3& p);
	
	double diagonalSquared() const;
	Point3 center() const;

private:
	Point3 minPoint;
	Point3 maxPoint;
};

}

#endif
