#ifndef _pc_geom_curve_h_
#define _pc_geom_curve_h_

/*
 *  Curve.h
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/27/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <PcMath/Vector3.h>
#include "Point3.h"
#include "QRotation.h"

namespace PcGeom {

using PcMath::Vector3;

class FloatCurve {

public:
	virtual float value(double t) const = 0;
};

class Vector3Curve {

public:
	virtual Vector3 value(double t) const = 0;
};

class Point3Curve {

public:
	virtual Point3 value(double t) const = 0;
};

class QRotationCurve {

public:
	virtual QRotation value(double t) const = 0;
};

}

#endif