#ifndef _pc_geom_piecewise_smooth_curve_h_
#define _pc_geom_piecewise_smooth_curve_h_

/*
 *  PiecewiseSmoothCurve.h
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/27/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "Curve.h"

namespace PcGeom {

class PiecewiseSmoothFloatCurve : public FloatCurve {

public:
	PiecewiseSmoothFloatCurve(const vector<double>& knots, const vector<float>& values);

	virtual float value(double t) const;

private:
	vector<double> knots;
	vector<float> values;
};

class PiecewiseSmoothVector3Curve : public Vector3Curve {

public:
	PiecewiseSmoothVector3Curve(const vector<double>& knots, const vector<Vector3>& values);

	virtual Vector3 value(double t) const;

private:
	vector<double> knots;
	vector<Vector3> values;
};

class PiecewiseSmoothPoint3Curve : public Point3Curve {

public:
	PiecewiseSmoothPoint3Curve(const vector<double>& knots, const vector<Point3>& values);

	virtual Point3 value(double t) const;

private:
	vector<double> knots;
	vector<Point3> values;
};

class PiecewiseSmoothQRotationCurve : public QRotationCurve {

public:
	PiecewiseSmoothQRotationCurve(const vector<double>& knots, const vector<QRotation>& values);

	virtual QRotation value(double t) const;

private:
	vector<double> knots;
	vector<QRotation> values;
};

}

#endif