#ifndef _pc_geom_transform_h_
#define _pc_geom_transform_h_

/*
 *  Transform.h
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/7/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <PcMath/Matrix4.h>

#include "Point3.h"

namespace PcGeom {

using PcMath::Matrix4;

class MatrixTransform;

class Transform {

public:
	/**
		returns the 4x4 homogeneous transform matrix of the transform
	*/
	virtual Matrix4 matrix() const = 0;
	
	/**
		transforms p and returns result
	*/
	virtual Point3 operator()(const Point3& p) const = 0;
	
	/**
		transforms p and returns result
	*/
	virtual Vector3 operator()(const Vector3& v) const = 0;
	
	MatrixTransform operator+(const Transform& rhs) const;

};

}

#endif