/*
 *  Translation.cpp
 *  PcGeom
 *
 *  Created by Patrick Coleman on 7/7/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "Translation.h"

namespace PcGeom {

Translation::Translation() {

}

Translation::Translation(const Point3& p) :
	translate(p.asVector3()) {
	
}

Translation::Translation(const Vector3& v) :
	translate(v) {
	
}
	
Matrix4 Translation::matrix() const {
	Matrix4 mat;
	mat[0][3] = translate.x;
	mat[1][3] = translate.y;
	mat[2][3] = translate.z;
	return mat;
}

Point3 Translation::operator()(const Point3& p) const {
	return p + translate;
}

Vector3 Translation::operator()(const Vector3& v) const {
	return v + translate;
}

}