#ifndef _pc_math_matrix_h_
#define _pc_math_matrix_h_

/*
 *  Matrix.h
 *  PcMath
 *
 *  Created by Patrick Coleman on 7/8/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <vector>

namespace PcMath {

using std::vector;

class Matrix {

public:
	Matrix(int numRows, int numCols);
	Matrix(const vector<vector<double> >& data);

	vector<double>& operator[](int i);
	const vector<double>& operator[](int i) const;
	
	void setToIdentity();
	void clear();
	
	int rowSize() const;
	int columnSize() const;
	
	
private:
	vector<vector<double> > data;
	
	void initializeData(int numRows, int numCols);

};

}

#endif