#ifndef _pc_math_matrix_4_h_
#define _pc_math_matrix_4_h_

/*
 *  Matrix4.h
 *  PcMath
 *
 *  Created by Patrick Coleman on 6/11/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <vector>

#include "Vector3.h"

namespace PcMath {

using std::vector;

class Matrix4 {

public:
	Matrix4();

	vector<double> & operator[](int i);
	const vector<double> & operator[](int i) const;
	
	Matrix4 operator*(const Matrix4& rhs) const;
	Vector3 operator*(const Vector3& rhs) const;
	
	double trace() const;
	double det() const;
	Matrix4 inverse() const;

	void setToIdentity();
	
private:
	vector<vector<double> > data;

private:
	void initializeData();

};

Matrix4 operator*(double s, const Matrix4& mat);

}

#endif