#ifndef _pc_math_quaternion_h_
#define _pc_math_quaternion_h_

/*
 *  Quaternion.h
 *  PcMath
 *
 *  Created by Patrick Coleman on 6/11/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <ostream>

#include "Vector3.h"

namespace PcMath {

using std::ostream;

class Quaternion {

public:
	Quaternion(double a = 1.0, double b = 0.0, double c = 0.0, double d = 0.0);
	Quaternion(double s, const Vector3& v);
	
	/**
		quat quat mult
	*/
	Quaternion operator*(const Quaternion& rhs) const;
	
	Quaternion operator+(const Quaternion& rhs) const;
	
	
	/**
		conjugation
	*/
	Quaternion conjugate() const;
	
	double dot(const Quaternion& rhs) const;
	
	Quaternion operator-() const;
	
public:
	double a;
	double b;
	double c;
	double d;
};

// ************** ops ***************

Quaternion operator*(double s, const Quaternion& rhs);

ostream& operator<<(ostream& output, const Quaternion& q);

}

#endif

