/*
 *  Vector3.h
 *  pcMath
 *
 *  Created by Patrick Coleman on 5/16/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#ifndef _pc_math_vector_3_h_
#define _pc_math_vector_3_h_

namespace PcMath {


class Vector3 {

public:
	Vector3(double x = 0.0, double y = 0.0, double z = 0.0);

	Vector3& operator=(const Vector3& rhs);

	Vector3 operator+(const Vector3& rhs) const;
	Vector3 operator-(const Vector3& rhs) const;
	Vector3& operator*=(double s);

	/**
		dot product
	*/
	double operator*(const Vector3& rhs) const;

	/**
		cross product
	*/
	Vector3 operator^(const Vector3& rhs) const;

	double length() const;
	double lengthSquared() const;
	Vector3 normalize() const;
	double angle(const Vector3& rhs) const;

public:
	double x;
	double y;
	double z;
};

// ************************** ops *****************************

Vector3 operator*(double s, const Vector3& rhs);


}

#endif