#ifndef _pc_motion_contact_h_
#define _pc_motion_contact_h_

/*
 *  Contact.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 8/18/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <map>
#include <string>
#include <vector>

#include <PcGeom/Point3.h>

namespace PcMotion {


using std::map;
using std::string;
using std::vector;
using PcGeom::Point3;

class Contact {

public:
	Contact(double startTime, double endtime, Point3 position);
	
	bool operator<(const Contact& rhs) const;

public:
	double startTime;
	double endTime;
	Point3 position;

};

typedef map<string, vector<Contact> > ContactMap;

}

#endif