#ifndef _pc_motion_motion_h_
#define _pc_motion_motion_h_

/*
 *  Motion.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 5/18/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "RigidHierarchicalObject.h"
#include "Pose.h"

namespace PcMotion {

/**
	Abstract motion superclass
	has attributes and a start time, attributes are just attr lists
*/
class Motion: public RigidHierarchicalObject {


public:
	Motion(double startTime);
	Motion(double startTime, const vector<string>& transAttrs, const vector<string>& rotAttrs);
	virtual ~Motion() {};
	
	virtual Point3 transValue(const string& attribute, double t) const = 0;
	virtual QRotation rotValue(const string& attribute, double t) const = 0;
	
	Pose getPoseAtTime(double t) const;
	
public:
	double startTime;
};

}

#endif