/*
 *  MotionSignal.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 5/22/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#ifndef _pc_motion_motion_signal_h_
#define _pc_motion_motion_signal_h_

#include <valarray>

using std::valarray

namespace PcMotion {


class MotionSignal {
	// ABANDONED
};


/**
	// ABANDONED
	class for storing samples of a motion
	time interpolation assumes indices are time values
	i.e. sample 0 is at t = 0, sample 19 is at t = 19, etc.
*/
template <class T, class Time>
class TypedMotionSignal: public AbstractMotionSignal {

public:
	TypedMotionSignal(const valarray<T>& values) {
		this->values = values;
	}
	
	// copy constructor
	
	// copy asssignment operator
	
	int length() const {
		return values.size();
	}
	
	T value(int t) const; // optimized for direct look up if an int is passed
	T value(const Time& t) const; 

	const T& operator[](int i) const;
	T& operator[](int i);
	
	void append(const T& value);
	
private:
	valarray<T> values;

};


/*
	 imp notes: just use floor ceiling to find indices when implementing value(Time)
*/


}

#endif