#ifndef _pc_motion_motion_transformation_h_
#define _pc_motion_motion_transformation_h_

/*
 *  MotionTransformation.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 6/24/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <PcFoundation/Reference.h>
#include "SampledMotion.h"

namespace PcMotion {

using PcFoundation::Reference;
	
class MotionTransformation {

public:
	
	/**
		applies transformation in-place
			subclasses must override
	*/
	//virtual void apply(Reference<USampledMotion>& originalMotion) const = 0;
	virtual void apply(SampledMotion* originalMotion) const = 0;
	
	
	/**
		operator notation does not change argument
		ok to override.  
		default implementation makes a copy and calls apply
	*/
	//virtual Reference<SampledMotion> operator()(const Reference<USampledMotion>& originalMotion) const;
	
private:
	//Reference<SampledMotion> originalMotion;
};
	
}

#endif