/*
 *  SkeletalConverter.cpp
 *  PcMotion
 *
 *  Created by Patrick Coleman on 7/2/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "SkeletalConverter.h"
#include "SkeletalPoseFitter.h"


namespace PcMotion {

SkeletalConverter::SkeletalConverter(const RigidHierarchy& hierarchy, const SampledMotion* referenceMotion) :
	rh(hierarchy), referenceMotion(referenceMotion) {
	
}
/*
void SkeletalConverter::apply(Reference<USampledMotion>& motion) const {
	
	int numSamples = motion->numSamples();
	SkeletalPoseFitter pf(rh);
	
	for (int i = 0; i < numSamples; i++) {
		pf.setReferencePose(referenceMotion->getPoseAtIndex(i));
		Pose p = motion->getPoseAtIndex(i);
		motion->setPoseAtIndex(i, pf(p));
	}
}
*/
void SkeletalConverter::apply(SampledMotion* motion) const {
	
	// make sure motion has the same rot attrs as the reference motion
	motion->setRotAttrs(referenceMotion->getRotAttrs());
	
	int numSamples = motion->numSamples();
	SkeletalPoseFitter pf(rh);
	
	for (int i = 0; i < numSamples; i++) {
		pf.setReferencePose(referenceMotion->getPoseAtIndex(i));
		Pose p = motion->getPoseAtIndex(i);
		motion->setPoseAtIndex(i, pf(p));
	}
}

}