#ifndef _pc_motion_skeletal_pose_fitter_h_
#define _pc_motion_skeletal_pose_fitter_h_

/*
 *  SkeletalPoseFitter.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 6/30/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "RigidHierarchy.h"
#include "Pose.h"

namespace PcMotion {

class SkeletalPoseFitter {

public:
	SkeletalPoseFitter(const RigidHierarchy& hierarchy, const Pose& referencePose = Pose());
	
	void setReferencePose(const Pose& rp);
	
	/**
		applies skeletal ik with least squares rotations, and translations for rotation residuals
		and stretching to match the referecne pose to the positions of the cartesian pose.
	*/
	Pose operator()(const Pose& euclideanPose) const; 

private:
	RigidHierarchy hierarchy;
	Pose referencePose;

};

}

#endif