#ifndef _pc_motion_spatial_pose_selector_h_
#define _pc_motion_spatial_pose_selector_h_

/*
 *  SpatialPoseSelector.h
 *  PcMotion
 *
 *  Created by Patrick Coleman on 7/26/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include <PcMath/Matrix.h>

#include "PoseSelector.h"

namespace PcMotion {

using PcMath::Matrix;
	
class SpatialPoseSelector: public PoseSelector {

public:
	SpatialPoseSelector(const Matrix& dmat, 
						float searchTol = 0.05, int minSearchWidth = 5, int maximaWidth = 20);
	
	virtual vector<int> getPoseIndices();

	// algorithmic intermediaries
	vector<float> getExtremeness();

private:
	void getBounds(vector<int>& priorBounds, vector<int>& nextBounds);
	void computeExtremeness(vector<int>& priorBounds, vector<int>& nextBounds);

private:
	const Matrix& dmat;
	float searchTol;
	int minSearchWidth;
	int maximaWidth;
	
	vector<float> extremeness;
	bool extremenessComputed;
};
	
}

#endif