/*
 *  USampledMotion.cpp
 *  PcMotion
 *
 *  Created by Patrick Coleman on 6/15/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "USampledMotion.h"

namespace PcMotion {

USampledMotion::USampledMotion(double startTime, double dTime) :
	SampledMotion(startTime, dTime),
	UberObject("USampledMotion") {

}
	
USampledMotion::USampledMotion(double startTime, 
							   const vector<string>& transAttrs, 
							   const vector<string>& rotAttrs,
							   double dTime) :
	SampledMotion(startTime, transAttrs, rotAttrs, dTime),
	UberObject("USampledMotion") {
				   
}

USampledMotion* USampledMotion::copy() const {
	USampledMotion* rsmCopy = new USampledMotion(startTime, transAttrs, rotAttrs, dTime);
	if (rsmCopy) {
		rsmCopy->setTransSignals(transSignals);
		rsmCopy->setRotSignals(rotSignals);
		rsmCopy->numReferences = 0;
	}
	return rsmCopy;
}	
	
}

