#ifndef _pc_signal_tent_filter_h_
#define _pc_signal_tent_filter_h_

/*
 *  TentFilter.h
 *  PcSignal
 *
 *  Created by Patrick Coleman on 8/27/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */

#include "Filter.h"

namespace PcSignal {

class FloatTentFilter: public FloatFilter {

public:
	FloatTentFilter(const FloatSignal& signal, int filterWidth);
	
	virtual FloatSignal output() const;
	
private:
	/*
		returns a weight mask for the signal, surrounding the index
	*/
	vector<float> getWeightMask(int index) const;
	
private:
	int filterWidth;
	int halfWidth;
	FloatSignal signal;

};

}

#endif