#ifndef _pc_signal_functions_h_
#define _pc_signal_functions_h_

/*
 *  functions.h
 *  PcSignal
 *
 *  Created by Patrick Coleman on 7/26/09.
 *  Copyright 2009 patrick coleman. All rights reserved.
 *
 */
 
#include <vector>

#include <PcMath/Vector3.h>
#include <PcGeom/Point3.h>
 
namespace PcSignal {

using std::vector;
using PcMath::Vector3;
using PcGeom::Point3;

vector<int> semilocalMaxima(vector<float> signal, int width = 5, bool includeBounds = false);

vector<Vector3> getVelocitySignal(const vector<Point3>& signal, double dt = 1.0);

vector<double> getSpeedSquaredSignal(const vector<Point3>& signal, double dt = 1.0);
	 
}

#endif
